#CONTROLCODES 1

TRUE = -1
FALSE = NOT TRUE
FIFO.SIZE = 4096

  A.REG = $030C
  X.REG = $030D
  Y.REG = $030E
  C.REG = $030F
  P.REG = C.REG

   r0=2
  r0l=r0
  r0h=3
   r1=4
  r1l=r1
  r1h=5
   r2=6
  r2l=r2
  r2h=7
   r3=8
  r3l=r3
  r3h=9
   r4=$A
  r4l=r4
  r4h=$B

Mem.Copy=$FEE7
CHKIN=$FFC6
CLRCHN=$FFCC
MACPTR=$FF44
AUDIO.Ctrl=$9F3B
AUDIO.Rate=$9F3C
AUDIO.FIFO=$9F3D

G.Bank1 = 62
G.Bank2 = 63
B.Base.Hi = $A0
B.Base.Lo = 0
B.Mid.Hi = $B0
B.Mid.Lo = 0
ROMADDR.H = $C0

PCM.Volume = 14
DEVICE = 8

DIM ZCM.Rate, ZCM.Audio.Size, ZCM.Ctrl
DIM Buffer(3)
DIM Banks(3)
DIM Hi.Ptr(3)
DIM Current.Play, Next.Play, Next.Load
DIM BYTES.Loaded, BYTES.Played, BYTES.Left2Load, BYTES.Left2Play
DIM Load.Complete, Play.Complete

   DEF FN FIFO.EMPTY(I)=(PEEK($9F3B) AND $40)>0
   DEF FN PEEKW(A)=PEEK(A)+(PEEK(A+1)*256)
   DEF FN SW(W)=W + 65536 * (W > 32767): REM CONVERT TO SIGNED RANGE
   DEF FN UW(W)=W-65536*(W<0): REM CONVERT TO UNSIGNED RANGE
   DEF FN Lo.Byte(X)=(FN SW(X)) AND $OOFF
   DEF FN Hi.Byte(X)=INT(FN UW(X)/256)


## Type ZCMHEADER
##    PTR As _Unsigned Integer
##    Bank As _Unsigned _Byte
##    Size As INT24
##    VERA_Cfg As _Unsigned _Byte
##    VERA_Rate As _Unsigned _Byte
## End Type

DIM ZCM.Header$
ZCM.Header$ = RPT$(32, 8)
DIM Is.HUGE.ZCM
Is.HUGE.ZCM = FALSE

ZCM$="AUTOBOOT.ZCM"
GOSUB PLAYZCM
F$="AUTOBOOT.OLD"
GOSUB FILEEXISTS
IF FE% THEN LOAD F$

THEEND:
 PRINT:NEW

PLAYZCM:
 GOSUB ZCM.Open
 IF ZCM.Error THEN RETURN
 POKE AUDIO.Ctrl, ZCM.Ctrl
 POKE AUDIO.Rate, 0
 POKE X.REG, 6
 SYS CHKIN
 GOSUB ZCM.LoadFifo
 POKE AUDIO.Rate, ZCM.Rate
 FOR I = 0 TO 2 STEP 0
    FOR TICK = 1 TO $40 STEP 0: TICK=(PEEK(AUDIO.CTRL) AND $40):NEXT
    FOR L = 1 TO LOOP.TARG
      POKE A.REG, 0
      POKE X.REG, $3D
      POKE Y.REG, $9F
      POKE C.REG, 1
      SYS MACPTR
      EOF=ST
      IF EOF THEN L=LOOP.TARG
      IF (PEEK(AUDIO.Ctrl) AND $80) THEN L=LOOP.TARG
    NEXT
 IF EOF THEN I = 2
 NEXT I
 SYS CLRCHN
 CLOSE 6
RETURN

ZCM.LoadFifo:
  FOR L = 0 TO $80 STEP 0
    POKE A.REG, 0
    POKE X.REG, $3D
    POKE Y.REG, $9F
    POKE C.REG, 1
    SYS MACPTR
    IF ST>0 THEN L=16
    L=(PEEK(AUDIO.Ctrl) AND $80)
  NEXT
  LOOP.TARG = FIFO.SIZE/(PEEK(Y.REG)*256)
  RETURN

ZCM.Open:
  ZCM.Error = FALSE
  F$=ZCM$:GOSUB FILEEXISTS
  ZCM.Error =  NOT FE%
  IF ZCM.Error THEN PRINT " 1 ";FE;" ";:GOTO ZCM.Fail
  OPEN 6,DEVICE,6, ZCM$+",S,R"
  GOSUB GETFILECODE
  ZCM.Error = NOT (FCode<20)
  IF ZCM.Error THEN CLOSE 6:GOTO ZCM.Fail
  BINPUT# 6, ZCM.Header$, 8

ZCM.Parse.Header:
  ZCM.Audio.Size = ASC(MID$(ZCM.Header$,4)) + (256 * ASC(MID$(ZCM.Header$,5,1))) + (65536 * ASC(MID$(ZCM.Header$,6,1)))
  ZCM.Ctrl = ASC(MID$(ZCM.Header$,7,1))
  V=PCM.Volume OR %11110000
  ZCM.Ctrl = ZCM.Ctrl AND V
  ZCM.Rate = ASC(MID$(ZCM.Header$,8,1))

LOADINIT:
  BYTES.Loaded=0
  BYTES.Played=0
  BYTES.Left2Load = ZCM.Audio.Size
  BYTES.Left2Play = ZCM.Audio.Size
  Load.Complete=FALSE
  Play.Complete=FALSE
  Playing=FALSE
  POKE AUDIO.Ctrl, ZCM.Ctrl
  POKE AUDIO.Rate, 0
 RETURN

ZCM.Fail:
 Print "{WHT}";ZCM$;"{LIGHT RED} NOT FOUND{LIGHT GREEN} !{WHT}":RETURN

ZCM.ShowInfo:
  PRINT "{GREEN}Audio Size{YEL}({LIGHT GREEN}Bytes{YEL}){WHT}:{YEL}";ZCM.Audio.Size;"{CR}"
  PRINT "{GREEN}Audio Rate{YEL}({LIGHT GREEN}HZ{YEL}){WHT}:{YEL}";INT((ZCM.Rate/128)*48824);"{CR}"
  PRINT "{GREEN}Audio CTRL{YEL}({LIGHT GREEN}BITMASK{YEL}){WHT}:{LIGHT RED}%{YEL} ";BIN$(ZCM.CTRL);"{CR}{WHT}"
  RETURN


FILEEXISTS:
  FF$=F$:FE%=0:FF$=FF$+",S,R"
  OPEN 2,DEVICE,2,FF$:CLOSE 2
  GOSUB GETFILECODE
  FE%=(FCode<20):RETURN

GETFILECODE:
  OPEN 15,8,15:INPUT#15,FCode,FC$,A,B:CLOSE 15:RETURN
